-- author: David Bartunek
-- Modul : Prepinac ktery kanal se ma zobrazit na sedmisegmentovkaCH
-- Vstup    :   clk   	                -> hodiny (100Mhz)
--              rst                     -> reset (aktivni v nule)
--              mux_chyby_segment_ch1   -> vstupni kanal
--              mux_chyby_segment_ch2   -> vstupni kanal
--              mux_chyby_segment_ch3   -> vstupni kanal
--              mux_chyby_segment_ch4   -> vstupni kanal
--              mux_chyby_segment_ch5   -> vstupni kanal
--              mux_chyby_segment_ch6   -> vstupni kanal
--              mux_chyby_segment_ch7   -> vstupni kanal
--              mux_chyby_segment_ch8   -> vstupni kanal
--              mux_chyby_segment_ch9   -> vstupni kanal
--              mux_chyby_segment_ch10  -> vstupni kanal
--              mux_chyby_segment_ch11  -> vstupni kanal
--              mux_chyby_segment_ch12  -> vstupni kanal
--              mux_chyby_segment_ch13  -> vstupni kanal
--              mux_chyby_segment_ch14  -> vstupni kanal
--              mux_chyby_segment_ch15  -> vstupni kanal
--              mux_chyby_segment_ch16  -> vstupni kanal
--              mux_switch              -> prepinace na vstupni kanaly

-- Vystup   :   mux_binary_out          -> vystupni data na sedmisegmentovku  

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

entity MUX_seg is
    port(
        
       --multiplexer
        clk :   in std_logic;
        rst :   in std_logic;

        mux_chyby_segment_ch1       :   in std_logic_vector(23 downto 0);
        mux_chyby_segment_ch2       :   in std_logic_vector(23 downto 0);
        mux_chyby_segment_ch3       :   in std_logic_vector(23 downto 0);
        mux_chyby_segment_ch4       :   in std_logic_vector(23 downto 0);
        mux_chyby_segment_ch5       :   in std_logic_vector(23 downto 0);
        mux_chyby_segment_ch6       :   in std_logic_vector(23 downto 0);
        mux_chyby_segment_ch7       :   in std_logic_vector(23 downto 0);
        mux_chyby_segment_ch8       :   in std_logic_vector(23 downto 0);
        mux_chyby_segment_ch9       :   in std_logic_vector(23 downto 0);
        mux_chyby_segment_ch10      :   in std_logic_vector(23 downto 0);
        mux_chyby_segment_ch11      :   in std_logic_vector(23 downto 0);
        mux_chyby_segment_ch12      :   in std_logic_vector(23 downto 0);
        mux_chyby_segment_ch13      :   in std_logic_vector(23 downto 0);
        mux_chyby_segment_ch14      :   in std_logic_vector(23 downto 0);
        mux_chyby_segment_ch15      :   in std_logic_vector(23 downto 0);
        mux_chyby_segment_ch16      :   in std_logic_vector(23 downto 0);
        mux_switch                  :   in std_logic_vector(3 downto 0);
        mux_binary_out              :   out std_logic_vector(23 downto 0)
    );
end entity;

architecture behav of MUX_seg is
       
    begin
            --multiplexer na vyber kanalu z 
        process(clk,rst)
            begin
                if(rst = '0') then
                    mux_binary_out <= x"FFFFFF"; -- pridano
                else
                case mux_switch is
                    when b"0000" =>   mux_binary_out <= mux_chyby_segment_ch1; 
                    when b"0001" =>   mux_binary_out <= mux_chyby_segment_ch2; 
                    when b"0010" =>   mux_binary_out <= mux_chyby_segment_ch3; 
                    when b"0011" =>   mux_binary_out <= mux_chyby_segment_ch4; 
                    when b"0100" =>   mux_binary_out <= mux_chyby_segment_ch5; 
                    when b"0101" =>   mux_binary_out <= mux_chyby_segment_ch6; 
                    when b"0110" =>   mux_binary_out <= mux_chyby_segment_ch7; 
                    when b"0111" =>   mux_binary_out <= mux_chyby_segment_ch8; 
                    when b"1000" =>   mux_binary_out <= mux_chyby_segment_ch9; 
                    when b"1001" =>   mux_binary_out <= mux_chyby_segment_ch10;
                    when b"1010" =>   mux_binary_out <= mux_chyby_segment_ch11;
                    when b"1011" =>   mux_binary_out <= mux_chyby_segment_ch12;
                    when b"1100" =>   mux_binary_out <= mux_chyby_segment_ch13;
                    when b"1101" =>   mux_binary_out <= mux_chyby_segment_ch14;
                    when b"1110" =>   mux_binary_out <= mux_chyby_segment_ch15;
                    when b"1111" =>   mux_binary_out <= mux_chyby_segment_ch16;
                    --when others => mux_binary_out <= mux_chyby_segment_ch1;
						  when others => mux_binary_out <= x"FFFFFF";
                  end case;
                end if; 
        end process;
end architecture;