library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;
use ieee.float_pkg.all;
use ieee.numeric_std_unsigned.all ; 

entity tb_top is
end tb_top;

architecture behav of tb_top is
    
    -- signaly hodiny a reset (reset aktivni v log '0')
    signal top_clk               :     std_logic := '0';
    signal top_rst               :     std_logic := '1' ;
    signal top_uart_rx           :     std_logic;
    signal top_switch_seg        :     std_logic_vector (3 downto 0);
    signal top_switch_vystup     :     std_logic_vector (1 downto 0);
    signal top_uart_tx           :     std_logic;

    --signal top_dir               :     std_logic;
    signal top_segmentovka0      :     std_logic_vector (6 downto 0);
    signal top_segmentovka1      :     std_logic_vector (6 downto 0);
    signal top_segmentovka2      :     std_logic_vector (6 downto 0);
    signal top_segmentovka3      :     std_logic_vector (6 downto 0);
    signal top_segmentovka4      :     std_logic_vector (6 downto 0);
    signal top_segmentovka5      :     std_logic_vector (6 downto 0);
    signal top_segmentovka6      :     std_logic_vector (6 downto 0);
    signal send_data_uart        :     std_logic_vector (7 downto 0);
    signal send                  :     std_logic;
    -- vnitrni signaly na obsluhu simulace
    signal stop: boolean := false;

begin
    
    uut:  entity work.top port map ( 
    top_clk,               
    top_rst,              
    top_uart_rx,           
    top_switch_seg,   
    top_switch_vystup,    
    top_uart_tx,           
    --top_dir,               
    top_segmentovka0,      
    top_segmentovka1,      
    top_segmentovka2,     
    top_segmentovka3,      
    top_segmentovka4,      
    top_segmentovka5,      
    top_segmentovka6,
    send_data_uart,
    send

    );

    top_uart_rx <= top_uart_tx;

    top_switch_seg <= "0000";
    top_switch_vystup <= "01";
  

    trans: process
    begin
        send <= '0', '1' after 100 ns;
        top_rst <= '0', '1' after 100 ns;
        send_data_uart <= x"88";
        wait for 5 us;
        send_data_uart <= x"88";
        wait for 5 us;
        send_data_uart <= x"88";
        wait for 5 us;
        send_data_uart <= x"F5";
        wait for 200 ns;
        send <= '0';
        wait for 10 us;

        send <= '0', '1' after 100 ns;
        send_data_uart <= x"88";
        wait for 5 us;
        send_data_uart <= x"88";
        wait for 5 us;
        send_data_uart <= x"88";
        wait for 5 us;
        send_data_uart <= x"F5";
        wait for 200 ns;
        send <= '0';
        wait for 10 us;

        send <= '0', '1' after 100 ns;
        send_data_uart <= x"88";
        wait for 5 us;
        send_data_uart <= x"45";
        wait for 5 us;
        send_data_uart <= x"82";
        wait for 5 us;
        send_data_uart <= x"F0";
        wait for 200 ns;
        send <= '0';
        wait for 10 us;

        send <= '0', '1' after 100 ns;
        send_data_uart <= x"88";
        wait for 5 us;
        send_data_uart <= x"88";
        wait for 5 us;
        send_data_uart <= x"82";
        wait for 5 us;
        send_data_uart <= x"F0";
        wait for 200 ns;
        send <= '0';
        wait for 10 us;

        send <= '0', '1' after 100 ns;
        send_data_uart <= x"88";
        wait for 5 us;
        send_data_uart <= x"88";
        wait for 5 us;
        send_data_uart <= x"82";
        wait for 5 us;
        send_data_uart <= x"F0";
        wait for 200 ns;
        send <= '0';
        wait for 10 us;
        wait;
    end process;

    stop_in:process
        begin
            wait for 200 us;
            stop <= true;
            wait;
         end process ;

    main_clock: process
    begin
        if(stop = false) then
            wait for 5 ns;
            top_clk <= not top_clk;
        else
            wait;
        end if;
    end process;
end behav;
