-- author: David Bartunek
-- Modul : Prevedeni 4 vstupnich byte, na jedno 32 bitove slovo
-- Vstup    :   clk   	            -> hodiny (100Mhz)
--              rst                 -> reset (aktivni v nule)
--              conv_data_in        -> 1 byte vstupnich dat
--              conv_valid_data_in  -> log.1 pokud jsou validni data na vstupu

-- Vystup   :   conv_data_out       -> data na vystupu  
--              conv_valid_data_out -> log.1 pokud jsou vylidni data na vystupu         

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity convert_byteTo4Byte is
    port(
        --convert 
        clk                     : in    std_logic;
        rst                     : in    std_logic;
        conv_data_in            : in    std_logic_vector(7 downto 0);
        conv_valid_data_in      : in    std_logic;
        
        conv_data_out           : out   std_logic_vector(31 downto 0);
        conv_valid_data_out     : out   std_logic;
        conv_restart_sync       : in    std_logic
    );
end entity;

architecture behav of convert_byteTo4Byte is

    signal number: integer := 0;
    signal data: std_logic_vector(31 downto 0);
    signal valid: std_logic := '0';

    begin
        
        conv_valid_data_out <= valid;
        conv_data_out <= data;
        process(conv_valid_data_in,rst )
        begin
                if(rising_edge(conv_valid_data_in)) then
                    if(number = 3) then
                        data(31 downto 24) <= (conv_data_in);
                        
								number <=  0;
                        valid <= '1';
								
                    elsif(number = 2) then
                        data(23 downto 16) <= (conv_data_in);
                        number <=  number + 1;
								valid <= '0';
								
                    elsif(number = 1) then
                        data(15 downto 8) <= (conv_data_in);
                        number <=  number + 1;
								valid <= '0';
								
                    elsif(number = 0) then
                        data(7 downto 0) <= (conv_data_in);
                        number <= number + 1;
								valid <= '0';
								
                    end if;
                end if;
					 if(rst = '0' or conv_restart_sync = '1') then
						number <= 0;
						valid <= '0';
					end if;
        end process;
end architecture;