-- author: David Bartunek
-- Modul : Ovladani sedmisegmentovek
-- Vstup    :   clk   	                -> hodiny (100Mhz)
--              rst                     -> reset (aktivni v nule)
--              segment_seg0_BNC_in     -> vstupni data na jednnotlive sedmisegmentovky
--              segment_seg1_BNC_in     -> vstupni data na jednnotlive sedmisegmentovky
--              segment_seg2_BNC_in     -> vstupni data na jednnotlive sedmisegmentovky
--              segment_seg3_BNC_in     -> vstupni data na jednnotlive sedmisegmentovky
--              segment_seg4_BNC_in     -> vstupni data na jednnotlive sedmisegmentovky
--              segment_seg5_BNC_in     -> vstupni data na jednnotlive sedmisegmentovky
--              segment_seg6_BNC_in     -> vstupni data na jednnotlive sedmisegmentovky

-- Vystup   :   segment_seg0_n          -> vystupni data na sedmisegmentovky
--              segment_seg1_n          -> vystupni data na sedmisegmentovky
--              segment_seg2_n          -> vystupni data na sedmisegmentovky
--              segment_seg3_n          -> vystupni data na sedmisegmentovky
--              segment_seg4_n          -> vystupni data na sedmisegmentovky
--              segment_seg5_n          -> vystupni data na sedmisegmentovky
--              segment_seg6_n          -> vystupni data na sedmisegmentovky

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

 
entity segment is
  port (
      --sedmisegmentovky
    clk                     :   in std_logic;
    rst                     :   in std_logic;
    segment_seg0_BNC_in     :   in std_logic_vector(3 downto 0);
    segment_seg1_BNC_in     :   in std_logic_vector(3 downto 0);
    segment_seg2_BNC_in     :   in std_logic_vector(3 downto 0);
    segment_seg3_BNC_in     :   in std_logic_vector(3 downto 0);
    segment_seg4_BNC_in     :   in std_logic_vector(3 downto 0);
    segment_seg5_BNC_in     :   in std_logic_vector(3 downto 0);
    segment_seg6_BNC_in     :   in std_logic_vector(3 downto 0);
    
    segment_seg0_n          :   out std_logic_vector(6 downto 0):="1111111";
    segment_seg1_n          :   out std_logic_vector(6 downto 0):="1111111";
    segment_seg2_n          :   out std_logic_vector(6 downto 0):="1111111";
    segment_seg3_n          :   out std_logic_vector(6 downto 0):="1111111";
    segment_seg4_n          :   out std_logic_vector(6 downto 0):="1111111";
    segment_seg5_n          :   out std_logic_vector(6 downto 0):="1111111";
    segment_seg6_n          :   out std_logic_vector(6 downto 0):="1111111"
    );
end entity;
 
architecture rtl of segment is

    function Cislo_segmentu(segment : integer := 0) return std_logic_vector is
        variable seg_n : std_logic_vector(6 downto 0);
        begin
           case segment is
                     when 0 => seg_n := "1000000";
                     when 1 => seg_n := "1111001";
                     when 2 => seg_n := "0100100";
                     when 3 => seg_n := "0110000";
                     when 4 => seg_n := "0011001";
                     when 5 => seg_n := "0010010";
                     when 6 => seg_n := "0000011";
                     when 7 => seg_n := "1111000";
                     when 8 => seg_n := "0000000";
                     when 9 => seg_n := "0011000";
                     when 10 => seg_n := "1111111";
                     when others => null;             
               end case; 
               return std_logic_vector(seg_n);  
        end function;
        
begin
    process (clk,rst)
    begin
        if(rst = '1') then
            segment_seg0_n <= Cislo_segmentu(to_integer(unsigned(segment_seg0_BNC_in)));
            segment_seg1_n <= Cislo_segmentu(to_integer(unsigned(segment_seg1_BNC_in)));
            segment_seg2_n <= Cislo_segmentu(to_integer(unsigned(segment_seg2_BNC_in)));
            segment_seg3_n <= Cislo_segmentu(to_integer(unsigned(segment_seg3_BNC_in)));
            segment_seg4_n <= Cislo_segmentu(to_integer(unsigned(segment_seg4_BNC_in)));
            segment_seg5_n <= Cislo_segmentu(to_integer(unsigned(segment_seg5_BNC_in)));
            segment_seg6_n <= Cislo_segmentu(to_integer(unsigned(segment_seg6_BNC_in)));
        else
            segment_seg0_n <= Cislo_segmentu(10);
            segment_seg1_n <= Cislo_segmentu(10);
            segment_seg2_n <= Cislo_segmentu(10);
            segment_seg3_n <= Cislo_segmentu(10);
            segment_seg4_n <= Cislo_segmentu(10);
            segment_seg5_n <= Cislo_segmentu(10);
            segment_seg6_n <= Cislo_segmentu(10);
        end if;
    end process;
end architecture rtl;