/*
 * ADS8689.h
 *
 *  Created on: 08. 1. 2022
 *      Author: David Bartunek
 */

#include <stdio.h>
#include "main.h"
#include <stdio.h>
#include <string.h>
#include <stdbool.h>

//uint8_t RxDataSPI_ADC_out[4];
//void TxSPI_init();

void TxSPI_init(uint8_t OPCODE,uint8_t addr,uint8_t TOP_data, uint8_t LOW_data);
#define ADC_ch1	1
#define ADC_ch2	2
#define ADC_ch3	3

//define driver pin to ADC

#define RS485_dir	GPIOB,GPIO_PIN_14

#define ADC_RVS_1	GPIOA,GPIO_PIN_9
#define ADC_RVS_2	GPIOA,GPIO_PIN_8
#define ADC_RVS_3	GPIOA,GPIO_PIN_10

#define ADC_RST_1	GPIOA,GPIO_PIN_12
#define ADC_RST_2	GPIOA,GPIO_PIN_11
#define ADC_RST_3	GPIOA,GPIO_PIN_10

#define ADC_SPI_CS_1	GPIOB,GPIO_PIN_12
#define ADC_SPI_CS_2	GPIOB,GPIO_PIN_10
#define ADC_SPI_CS_3	GPIOB,GPIO_PIN_13

#define	LED_1	GPIOC,GPIO_PIN_6
#define LED_2	GPIOC,GPIO_PIN_8
#define LED_3	GPIOC,GPIO_PIN_9

#define ADC_ALARM_1	GPIOB,GPIO_PIN_4
#define ADC_ALARM_2 GPIOB,GPIO_PIN_6
#define ADC_ALARM_3 GPIOB,GPIO_PIN_5

//SPI OPCODE
#define ADC8689_NOP 0x00	//0b00000000
#define CLEAR_HWORD 0xC0	//0b11000000
#define READ_HWORD  0xC8	//0b11001000
#define READ        0x48	//0b01001000
#define WRITE1      0xD0	//0b11010000
#define WRITE2      0xD2	//0b11010010
#define WRITE3      0xD4	//0b11010100
#define SET_HWORD   0xD8	//0b11011000

/*
DEVICE_ID_REG
This register contains the unique identification numbers associated to a device that is used in a daisy-chain
configuration involving multiple devices.
*/
#define DEVICE_ID_REG_LOW 0x00 //spodni registry
#define DEVICE_ID_REG_TOP 0x02 //horni registry


#define RST_PWRCTL_REG_LOW 0x04       //spodni registry
#define RST_PWRCTL_REG_TOP 0x06       //horni registry

/*
SDI_CTL_REG 0x08
This register configures the protocol used for writing data to the device
*/
#define SDI_CTL_REG_LOW 0x08       //spodni registry   
#define SDI_CTL_REG_TOP 0x0A       //horni registry     

/*
SDO_CTL_REG
his register controls the data protocol used to transmit data out from the SDO-x pins of the device
*/
#define SDO_CTL_REG_LOW 0x0C      //spodni registry        
#define SDO_CTL_REG_TOP 0x0E      //horni registry     

/*
DATAOUT_CTL_REG
This register controls the data output by the device.
*/
#define DATAOUT_CTL_REG_LOW 0x10   //spodni registry   
#define DATAOUT_CTL_REG_TOP 0x12   //horni registry  

/*
RANGE_SEL_REG
This register controls the configuration of the internal reference and input voltage ranges for the converter.
*/
#define RENGE_SEL_REG_LOW 0x14     //spodni registry  
#define RENGE_SEL_REG_TOP 0x16     //horni registry  

/*
ALARM_REG
This register contains the output alarm flags (active and tripped) for the input and AVDD alarm
*/
#define ALARM_REG_LOW 0x20         //spodni registry 
#define ALARM_REG_TOP 0x22         //horni registry  

/*
ALARM_H_TH_REG
This register controls the hysteresis and high threshold for the input alarm
*/
#define ALARM_H_TH_REG_LOW 0x24    //spodni registry 
#define ALARM_H_TH_REG_TOP 0x26    //horni registry 


/*
ALARM_L_TH_REG
This register controls the low threshold for the input alarm.
*/
 #define ALARM_L_TH_REG_LOW 0x28    //spodni registry 
 #define ALARM_L_TH_REG_TOP 0x2A    //horni registry
