/*
 * ADS8689.c
 *
 *  Created on: Mar 7, 2022
 *      Author: bartu
 */

#include "ADS8689.h"
SPI_HandleTypeDef hspi1;
CRC_HandleTypeDef hcrc;
UART_HandleTypeDef huart1;

void Drive_CS_CONV(uint8_t channel, bool log_value);
bool Read_RVS(uint8_t channel);
//void TxSPI_init();	// TODO, dodelat inicializaci
void TxSPI_init(uint8_t OPCODE,uint8_t addr,uint8_t TOP_data, uint8_t LOW_data);
void RxSPI();		// TODO, dodelat vycitani z libovolneho registru
/*
 * Funkce na rizeni CS a CONV
 * Vstupní parametry: cislo ADC prevodniku, a log. hodnota na kterou se ma preklopit
 */

bool ADC_CS_CONV_state_1 = 0;
bool ADC_CS_CONV_state_2 = 0;
bool ADC_CS_CONV_state_3 = 0;

void Drive_CS_CONV(uint8_t channel, bool log_value) {

	if (log_value == 1) {
		switch (channel) {
		case 1:
			HAL_GPIO_WritePin(ADC_SPI_CS_1, 1);
			ADC_CS_CONV_state_1 = 1;
			break;
		case 2:
			HAL_GPIO_WritePin(ADC_SPI_CS_2, 1);
			ADC_CS_CONV_state_2 = 1;
			break;
		case 3:
			HAL_GPIO_WritePin(ADC_SPI_CS_3, 1);
			ADC_CS_CONV_state_3 = 1;
			break;
		}
	}
	if (log_value == 0) {
		switch (channel) {
		case 1:
			HAL_GPIO_WritePin(ADC_SPI_CS_1, 0);
			ADC_CS_CONV_state_1 = 0;
			break;
		case 2:
			HAL_GPIO_WritePin(ADC_SPI_CS_2, 0);
			ADC_CS_CONV_state_2 = 0;
			break;
		case 3:
			HAL_GPIO_WritePin(ADC_SPI_CS_3, 0);
			ADC_CS_CONV_state_3 = 0;
			break;
		}
	}

}

/*
 * Funkce na cteni signalu RVS
 * Vstup je pin ktery cheme precist
 */
bool ADC_RVS_state_1 = 0;
bool ADC_RVS_state_2 = 0;
bool ADC_RVS_state_3 = 0;

bool ADC_RVS_state_1_previous = true;
bool ADC_RVS_state_2_previous = true;
bool ADC_RVS_state_3_previous = true;
bool Read_RVS(uint8_t channel) {

	switch (channel) {
	case 1:
		ADC_RVS_state_1 = HAL_GPIO_ReadPin(ADC_RVS_1);

		if ((ADC_RVS_state_1_previous == 0) && (ADC_RVS_state_1 == 1)) {
			ADC_RVS_state_1_previous = ADC_RVS_state_1;
			return ADC_RVS_state_1;
		} else {
			ADC_RVS_state_1_previous = ADC_RVS_state_1;
			return ADC_RVS_state_1_previous;
		}

		break;
	case 2:
		ADC_RVS_state_2 = HAL_GPIO_ReadPin(ADC_RVS_2);

		if ((ADC_RVS_state_2_previous == 0) && (ADC_RVS_state_2 == 1)) {
			ADC_RVS_state_2_previous = ADC_RVS_state_2;
			return ADC_RVS_state_2;
		} else {
			ADC_RVS_state_2_previous = ADC_RVS_state_2;
			return ADC_RVS_state_2_previous;
		}
		break;
	case 3:
		ADC_RVS_state_3 = HAL_GPIO_ReadPin(ADC_RVS_3);

		if ((ADC_RVS_state_3_previous == 0) && (ADC_RVS_state_3 == 1)) {
			ADC_RVS_state_3_previous = ADC_RVS_state_3;
			return ADC_RVS_state_3;
		} else {
			ADC_RVS_state_3_previous = ADC_RVS_state_3;
			return ADC_RVS_state_3_previous;
		}
		break;
	}
}

uint8_t TxDataSPI_clear[4];
void Clear_Register_ADS8689(uint8_t addr,uint8_t TOP_data, uint8_t LOW_data){

	TxDataSPI_clear[0] = CLEAR_HWORD;
	TxDataSPI_clear[1] = addr;
	TxDataSPI_clear[2] = TOP_data;
	TxDataSPI_clear[3] = LOW_data;

	Drive_CS_CONV(ADC_ch3,0);

		if (HAL_SPI_Transmit_DMA(&hspi1, (uint8_t*) TxDataSPI_clear, 4)
				!= HAL_OK) {
			Error_Handler();
		} else {
			Drive_CS_CONV(ADC_ch3,1);
		}
}

/*
 *	Funkce na odeslani inicializacnich dat
 *	odesila se 12 bytu. Jako prvni je OPCODE, pak adresa, a nasleduji 16 bit data
 */

uint8_t TxDataSPI_init_all[4];
void TxSPI_init(uint8_t OPCODE,uint8_t addr,uint8_t TOP_data, uint8_t LOW_data) {

	TxDataSPI_init_all[0] = OPCODE;
	TxDataSPI_init_all[1] = addr;
	TxDataSPI_init_all[2] = TOP_data;
	TxDataSPI_init_all[3] = LOW_data;

	Drive_CS_CONV(ADC_ch2,0);

	if (HAL_SPI_Transmit_DMA(&hspi1, (uint8_t*) TxDataSPI_init_all, 4)
			!= HAL_OK) {
		Error_Handler();
	} else {
		Drive_CS_CONV(ADC_ch2,1);
	}

}

// funkce na vycteni registru
//uint8_t TxDataSPI_ADC_out[4] = {READ_HWORD, DEVICE_ID_REG_TOP, 0x00, 0x00 };
uint8_t TxDataSPI_ADC_out[4] = {ADC8689_NOP, 0x00, 0x00, 0x00 };
uint8_t RxDataSPI_ADC_out[4];



void TxSPI() {

	//vyslani OPCODU pres SPI na vycteni registru
	//HAL_SPI_Receive_DMA(&hspi1, RxDataSPI_ADC_out, 4);
	HAL_SPI_TransmitReceive_DMA(&hspi1, TxDataSPI_ADC_out, RxDataSPI_ADC_out, 4);

}

uint8_t result_value[4];
uint16_t conv_result;
uint8_t device_addr;
uint8_t AVDD_alarm_flag;
uint8_t Input_alarm_flag;
uint8_t ADC_input_range;
uint8_t parity_bits;

float real_value;

uint8_t data_with_CRC[4];
uint8_t data_bez_CRC[3];
void HAL_SPI_TxRxCpltCallback(SPI_HandleTypeDef *hspi){

		/*result_value[0]=RxDataSPI_ADC_out[3]; // hodni bity vysledku
		result_value[1]=RxDataSPI_ADC_out[2]; // dolni bity vysledku
		result_value[2]=RxDataSPI_ADC_out[1];
		result_value[3]=RxDataSPI_ADC_out[0];*/

		conv_result =  (RxDataSPI_ADC_out[0]<<8) | RxDataSPI_ADC_out[1]; 	// spodni bity prenosu
		device_addr = (RxDataSPI_ADC_out[2] & 0xF0)>>4;						// addresa zarizeni
		ADC_input_range = (RxDataSPI_ADC_out[2] & 0x0F);					// vstupni rozliseni
		AVDD_alarm_flag = (RxDataSPI_ADC_out[3] & 0xC0)>>6;					//flag

		if((RxDataSPI_ADC_out[0] & 0x80) == 0x80){
			real_value =(conv_result - 0x8000)*0.000375;
		}
		else{
			real_value = (conv_result - 0x8000)*0.000375;
		}

		// prevedenej vysledek na float

/*
			data_bez_CRC[2] = RxDataSPI_ADC_out[1];	// spodni byte data   (V kalkulatoru uplne vpravo)
			data_bez_CRC[1] = RxDataSPI_ADC_out[0]; // horni byte data
			data_bez_CRC[0] = RxDataSPI_ADC_out[2];	// ridici data  (v kalkulatoru uplne vlevo) zapnuta rverzace vystupu
*/
			/*data_bez_CRC[2] = 0x82;	// spodni byte data   (V kalkulatoru uplne vpravo)
			data_bez_CRC[1] = 0x4B; // horni byte data
			data_bez_CRC[0] = 0x15;	// ridici data  (v kalkulatoru uplne vlevo) zapnuta rverzace vystupu*/

		data_bez_CRC[2] = RxDataSPI_ADC_out[1];	// spodni byte data   (V kalkulatoru uplne vpravo)
	    data_bez_CRC[1] = RxDataSPI_ADC_out[0]; // horni byte data
		data_bez_CRC[0] = RxDataSPI_ADC_out[2];	// ridici data  (v kalkulatoru uplne vlevo) zapnuta rverzace vystupu


	  uint8_t uwCRCValue = HAL_CRC_Calculate(&hcrc,data_bez_CRC, 3); // vypocet CRC
	 // CRC->DR = 0x121212;
	  data_with_CRC[3] = data_bez_CRC[0];
	  data_with_CRC[2] = data_bez_CRC[1];
	  data_with_CRC[1] = data_bez_CRC[2];
	  data_with_CRC[0] = uwCRCValue;
//	  data_with_CRC[0] = 0x00;

	 HAL_UART_Transmit(&huart1,  (uint8_t *)data_with_CRC, 4,1);


}

void HAL_UART_TxCpltCallback(UART_HandleTypeDef *huart){

	HAL_GPIO_TogglePin(LED_2);

}

